using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_user_login_log")]
    public class SecurityUserLoginLogEntity : EntityBase<long>
    {

    public SecurityUserLoginLogEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
    [Column("login_log_id")]
    public long LoginLogId  { get; set; }
    [Column("user_name")]
    public string UserName  { get; set; }
    [Column("agent_user_name")]
    public string? AgentUserName  { get; set; }
    [Column("ip_address")]
    public string? IpAddress  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string LOGIN_LOG_ID = "LoginLogId";
    public const string USER_NAME = "UserName";
    public const string AGENT_USER_NAME = "AgentUserName";
    public const string IP_ADDRESS = "IpAddress";

    public const string DB_NAME_SECURITY_USER_LOGIN_LOG = "security_user_login_log";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,login_log_id,user_name,agent_user_name,ip_address";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_LOGIN_LOG_ID = "login_log_id";
    public const string DB_USER_NAME = "user_name";
    public const string DB_AGENT_USER_NAME = "agent_user_name";
    public const string DB_IP_ADDRESS = "ip_address";


    public static SecurityUserLoginLogEntity GetInstance()
    {
        return new SecurityUserLoginLogEntity();
    }

    public virtual void CopyFrom(SecurityUserLoginLogEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityUserLoginLogEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.LoginLogId =  source.LoginLogId;
        this.UserName =  source.UserName;
        this.AgentUserName =  source.AgentUserName;
        this.IpAddress =  source.IpAddress;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_USER_LOGIN_LOG}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_USER_LOGIN_LOG}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_LOGIN_LOG_ID ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_USER_LOGIN_LOG}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityUserLoginLogEntity Clone()
    {
        SecurityUserLoginLogEntity result = new SecurityUserLoginLogEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
